<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
global $sourcedir;
	
include_once($sourcedir . '/itemstats/dbconfig.php');
include_once($sourcedir . '/itemstats/includes/sqlhelper.php');

// Interface to the item cache.
class ItemCache
{
	var $sql;

	// Constructor
	function ItemCache() 
	{
		$this->sql = new SqlHelper(dbhost, dbname, dbuser, dbpass);
		
		// lets check if the item_cache table already exists
		$table_exists = false;
		$checkTable = $this->sql->query("CHECK TABLE " . item_cache_table . " FAST QUICK");
		$checkResult = mysql_fetch_row($checkTable);
		
		if(!strstr($checkResult[3],"doesn't exist"))
		{
		  $table_exists = true;
		}

    if ($table_exists == false)
    {
		  // Create the item cache table.		             
		  $query = "CREATE TABLE `" . item_cache_table . "` (
						    `item_name` varchar(100) NOT NULL default '',
						    `item_link` varchar(100) default NULL,
						    `item_color` varchar(20) NOT NULL default '',
						    `item_icon` varchar(50) NOT NULL default '',
						    `item_html` text NOT NULL,
						    `item_id` varchar(100) default NULL,
						    `item_source` varchar(5) NOT NULL default '0',
						    `item_method` varchar(5) NOT NULL default 'find',
						    `item_found` varchar(5) NOT NULL default '0',
						    UNIQUE KEY `item_name` (`item_name`),
						    FULLTEXT KEY `item_html` (`item_html`)) TYPE=MyISAM";
    											
		  $result = $this->sql->query($query);
		}
		else
		{
		  // ok the item cache table already exists
		  // now check if the new fields already exists maybe it's an old one...
		  $result = $this->sql->query("SHOW COLUMNS FROM " . item_cache_table);
  		
  		$field_id_exists = false;
  		$field_source_exists = false;
  		$field_method_exists = false;
  		$field_found_exists = false;
  		
		  while ($tempfield = $this->sql->fetch_record($result))
		  {
			  if($tempfield['Field'] == 'item_id')
			    $field_id_exists = true;
			    
			  if($tempfield['Field'] == 'item_source')
			    $field_source_exists = true;
			    
			  if($tempfield['Field'] == 'item_method')
			    $field_method_exists = true;
			    
			  if($tempfield['Field'] == 'item_found')
			    $field_found_exists = true;
		  }
		  
		  if($field_id_exists == false)
		    $result = $this->sql->query("ALTER TABLE " . item_cache_table . " ADD " . 
		                                "item_id varchar(100) default NULL");
		                                
		  if($field_source_exists == false)
		    $result = $this->sql->query("ALTER TABLE " . item_cache_table . " ADD " .
		                                "item_source varchar(5) NOT NULL default '0'");
		                                
		  if($field_method_exists == false)
		    $result = $this->sql->query("ALTER TABLE " . item_cache_table . " ADD " .
		                                "item_method varchar(5) NOT NULL default 'find'");
		                                
		  if($field_found_exists == false)
		    $result = $this->sql->query("ALTER TABLE " . item_cache_table . " ADD " .
		                                "item_found varchar(5) NOT NULL default '0'");
		}
	}

	// Cleans up resources used by this object.
	function close()
	{
		$this->sql->close();
	}
	
	// Returns the proper name for the specified item.
	function getItemName($name, $source)
	{
	  $item_name = '';
	  
		$item_name = $this->sql->query_first("SELECT item_name FROM " . item_cache_table . 
		                                     " WHERE item_name = '" . addslashes($name) . "'");
		                               
		if (empty($item_name))
		{
		  // hmm maybe we must use the $name as id so lets try		  
			$item_name = '';
			
			$item_name = $this->sql->query_first("SELECT item_name FROM " . item_cache_table . 
													                 " WHERE item_id = '" . addslashes($name) .
												                   "' AND item_source = '" . addslashes($source) . "'");
	  }
	  
	  return $item_name;                               
	}
	
	// Returns the proper id for the specified item.
	function getItemId($name)
	{		
		return $this->sql->query_first("SELECT item_id FROM " . item_cache_table . 
											             " WHERE item_name = '" . addslashes($name) . "'");
	}
  
	// Returns the proper source for the specified item.
 	function getItemSource($name)
	{
		return $this->sql->query_first("SELECT item_source FROM " . item_cache_table . 
										               " WHERE item_name = '" . addslashes($name) . "'");
	}

	// Returns the proper method for the specified item.
	function getItemMethod($name)
	{
		return $this->sql->query_first("SELECT item_method FROM " . item_cache_table . 
										               " WHERE item_name = '" . addslashes($name) . "'");
  }

	// Returns the link for the specified item.
	function getItemLink($name)
	{
		return $this->sql->query_first("SELECT item_link FROM " . item_cache_table . 
		                               " WHERE item_name = '" . addslashes($name) . "'");
	}
	
	// Returns the color class for the specified item.
	function getItemColor($name)
	{
		return $this->sql->query_first("SELECT item_color FROM " . item_cache_table . 
		                               " WHERE item_name = '" . addslashes($name) . "'");
	}

	// Returns the icon for the specified item.
	function getItemIcon($name)
	{
		return $this->sql->query_first("SELECT item_icon FROM " . item_cache_table . 
		                               " WHERE item_name = '" . addslashes($name) . "'");
	}

	// Returns the html for the specified item.
	function getItemHtml($name)
	{
		return $this->sql->query_first("SELECT item_html FROM " . item_cache_table . 
		                               " WHERE item_name = '" . addslashes($name) . "'");
	}

	// Returns a list of all items in the database.
	function getItems()
	{
	  /*
		$result = $this->sql->query("SELECT item_name FROM " . item_cache_table);
		
		$items = array();
		while ($item = $this->sql->fetch_record($result))
		{
			array_push($items, $item['item_name']);
		}
		
		return $items;
		*/
	}

	function saveItem($item)
	{
		if (!isset($item))
		{
			return false;
		}
		
		// Delete any existing entry for this item.
    $this->sql->query("DELETE FROM " . item_cache_table . " WHERE item_name = '" . addslashes($item['name']) . "'");		
		$this->sql->query("DELETE FROM " . item_cache_table . " WHERE item_name = '" . addslashes($item['id']) . "'");

		// Add the entry to the database.					          
	  $result = $this->sql->query("INSERT INTO " . item_cache_table . 
	                              " (item_name, item_id, item_source, item_method," .
	                              " item_link, item_color, item_icon, item_html, item_found)" .
	                              " VALUES (" .
											          "'" . addslashes($item['name']) . "', " . 
											          "'" . addslashes($item['id']) . "', " .
											          "'" . addslashes($item['source']) . "', " .
											          "'" . addslashes($item['method']) . "', " .
											          (empty($item['link']) ? 'NULL' : "'" . addslashes($item['link']) . "'") . ", " .
											          "'" . addslashes($item['color']) . "', " .
											          "'" . addslashes($item['icon']) . "', " .
											          "'" . addslashes($item['html']) . "', " .
											          "'" . addslashes($item['found']) . "')");	

		if (!$result)
		{
			$error = $this->sql->error();
			$error = $error['message'];
			echo "Failed to update item: " . $item['name'] . " (" . $error . ")";
		}
		
		return $result;
	}
	
	function deleteNotFoundItems()
	{
		$result = $this->sql->query_first("DELETE FROM " . item_cache_table . 
											                " WHERE item_found = '0'");
	}
}
?>