<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function downloadFile($url)
{
	$file = '';
	
	// Only http requests are supported.
	// Check if we have a supported url.
	if (strpos($url, 'http://') !== false)
	{	
		$file = downloadUsingSocks($url);

		// if $content = false try CURL
		if ($file === false || empty($file))
		{
			$file = downloadUsingCURL($url);

			// if $content is false again try fopen/file_get_contents
			if ($file === false || empty($file))
			{
				$file = downloadUsingFOpen($url);
				
				if ($file === false || empty($file))
				{
					// TODO log error
					return false;
				}
			}
		}
	}
	else
	{
		// TODO log error
		return false;	
	}

	return $file;
}

function downloadUsingSocks($url)
{
	// Only http requests are supported.
	// Check if we have a supported url.
	if (strpos($url, 'http://') !== false)
	{
		// now split it up
		preg_match("#http://(.*)/(.*)$#Ui", $url, $splitup);
		$host = $splitup[1];
		$page = $splitup[2];

		// now connect to the page and get the data
		$fp = fsockopen($host, 80, $errno, $errstr, 30);

		if (!$fp)
		{
			// TODO log error
			log_error('function downloadUsingSocks: ' . $errno . ' ' . $errstr);
			return false;
		}

		$send = "GET /$page HTTP/1.0\r\n";
		$send .= "Host: $host\r\n";
		//$send .= "Referer: $referer\r\n";
		$send .= "User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1\r\n\r\n";
		$send .= "Connection: Close\r\n\r\n";

		fwrite($fp, $send);

		// Just skip the header as we don't need it
		while (!feof($fp) && trim($header = fgets($fp, 4096)) != '')
		{
		}

		// get the rest of the content and return it
		$file = '';
		while (!feof($fp))
		{
			$file .= fread($fp, 4096);
		}

		return $file;
	}
	else
	{
		// TODO log error
		log_error('function downloadUsingSocks: Sorry wrong url type.');
		return false;
	}
}

function downloadUsingCURL($url)
{
	// Only http requests are supported.
	// Check if we have a supported url.
	if (strpos($url, 'http://') !== false)
	{
		// check if curl is available
		if (function_exists('curl_init'))
		{
			$ch = curl_init();
			
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			
			$file = curl_exec($ch);
			
			if(curl_errno($ch))
			{
				// TODO log error
				log_error('function downloadUsingCURL: ' . curl_errno($ch) . ' ' . curl_error($ch));
				return false;	
			}
			else
			{
				curl_close($ch);
			}
				
			return $file;
		}
		else
		{
			// TODO log error
			return false;
		}
	}
	else
	{
		// TODO log error
		log_error('function downloadUsingCURL: Sorry wrong url type.');
		return false;
	}
}

function downloadUsingFOpen($url)
{
	// Only http requests are supported.
	// Check if we have a supported url.
	if (strpos($url, 'http://') !== false)
	{
		if (ini_get('allow_url_fopen') == 1)
		{
			$file = file_get_contents($url);

			if (empty($file))
			{
				// TODO log error
				log_error('function downloadUsingFOpen: Sorry something went wrong...');
				return false;	
			}
		}
		else
		{
			// TODO log error
			log_error('function downloadUsingFOpen: Sorry allow_url_fopen is set to 0. Please check your php.ini file.');
			return false;
		}
		
		return $file;
	}
	else
	{
		// TODO log error
		log_error('function downloadUsingFOpen: Sorry wrong url type.');
		return false;
	}
}
?>