<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
require_once(dirname(__FILE__) . '/xmlhelper.php');
require_once(dirname(__FILE__) . '/HTTPDownloader.php');
require_once(dirname(__FILE__) . '/LocalFileReader.php');

define('DEFAULT_ICON_ALLAKHAZAM', 'INV_Misc_QuestionMark');

// The main interface to the Allakhazam
class WoWAllakhazam
{
	var $xml_helper;
	var $method = 'find'; //set default to find...
	
	// Constructor
	function WoWAllakhazam($method)
	{
		$this->xml_helper = new XmlHelperDC14();
		
		if (!empty($method))
			$this->method = $method;
	}
	
	// Cleans up resources used by this object.
	function close()
	{
		$this->xml_helper->close();
	}

	// Attempts to retrieve data for the specified item from Allakhazam.
	function getItem($name)
	{
		global $settings;

		// Ignore blank names.
		$tempname = trim($name);
		if (empty($tempname))
		{
			return null;
		}

		// set default value...
		$item_found = false;
		$itemid_found = false;
		$item = array('name' => $name);
		$item['source'] = '0';
		$item['method'] = $this->method;
		$item['id'] = '-1';
		$item_variant = false;
		$item_variant_html = "";
		
		if (is_numeric($name))
		{
			$this->method = 'id';
		}

		if ($this->method =='id')
		{
			$item['method'] = 'id';
			$item['source'] = '0';
			$item_id = intval($name, 10);
			$itemid_found = true;
			$item_variant = false;
		}
		else
		{
			// Perform the search.
			$data = downloadFile('http://wow.allakhazam.com/cluster/item-search.pl?itemname=' . str_replace('%20','+',urlencode($name)) . '&showall=1&locale=enUS&search=1');

			if($data !== false)
			{
				// Look for a name match in the search result.
				if (preg_match_all('#images/icons/(.*?)\.png(.*?)<a class="(.*?)"(.*?)witem=(.*?)">(.*?)</a>#s', $data, $matches))
				{
					foreach ($matches[0] as $key => $match)
					{
						// Extract the item's name from the match.
						$tempname = $matches[6][$key];
	
						// now check if this is the item we searched
						if(strtoupper($name) == strtoupper($tempname))
						{
							$name = $tempname;
							$item['method'] = 'find';
							$item['source'] = '0';
	
							// Extract the item's ID from the match.
							$item_id = intval($matches[5][$key], 10);
							
							/*
							// Item Variant search doesn't work at the moment 09.05.2008
							// check if the found item is a variant of the id above
							if ($matches[5][$key] != '0')
							{
								$item_variant = true;
							}*/
	
							$itemid_found = true;
							break;
						}
					}
				}
				
				/*
				// Item Variant search doesn't work at the moment 09.05.2008
				if ($item_variant)
				{
					foreach ($matches[0] as $key => $match)
					{
						$item_variant_id1 = $matches[4][$key];
						$item_variant_id2 = $matches[5][$key];
	
						$variant_data = downloadFile('http://wow.allakhazam.com/cluster/ifull.pl?id=' . $item_variant_id1 . ':' . $item_variant_id2 . '&locale=enUS&source=live');
	
						if($variant_data !== false)
							$item_variant_html = $item_variant_html . $variant_data;
					}
				}
				*/
			}
		}

		if($itemid_found == true)
		{			
			// Retrieve the XML for this item from Allakhazam.
			$xml_data = downloadFile('http://wow.allakhazam.com/cluster/item-xml.pl?witem=' . $item_id);			

			if ($xml_data !== false)
			{
				// ok check if we really got a valid xml file
				$tempname = $this->xml_helper->fetch($xml_data, 'wowitem/name1');
				$tempicon = $this->xml_helper->fetch($xml_data, 'wowitem/icon');

				if ($tempname !== false && $tempicon !== false)
				{
					$tempicon = str_replace('/images/icons/', '', $tempicon);
					$xml_icon = str_replace('.png', '', $tempicon);
					
					if (!$item_variant)
					{	
						$item['name'] = itemstats_fixname_dc14($tempname);
					}
					else
					{
						$item['name'] = itemstats_fixname_dc14($name);
					}
					$item['id'] = $item_id;
					$item['icon'] = $xml_icon;
					$item['link'] = 'http://wow.allakhazam.com/db/item.html?witem=' . $item_id;
					$item['found'] = '1';

					$item_found = true;
				}
			}
		}
		
		// If a match was found, retrieve additional info about it.		
		if ($item_found)
		{
			$item_parse_failed = false;
			
			// Parse out the display html of this item from the XML if it's not a variant		
			if (!$item_variant)
			{
			  $item['html'] = $this->xml_helper->fetch($xml_data, 'wowitem/display_html');
			}
			else
			{
			  $item['html'] = $item_variant_html;
			}
			
			if ($item['html'] !== false)
			{
				// Fix up the html a bit.
				$item['html'] = str_replace('"', '\'', $item['html']);
				$item['html'] = str_replace("\r", '', $item['html']);
				$item['html'] = str_replace("\n", '', $item['html']);
				$item['html'] = str_replace('<br/>', '<br />', $item['html']);
				$item['html'] = str_replace("<a href='http://wow.allakhazam.com/db/itemset", "<a class='set' href='http://wow.allakhazam.com/db/itemset", $item['html']);
				$item['html'] = str_replace("<a", "<a target='_new'", $item['html']);
				$item['html'] = preg_replace("#<a ([^>]*) class='itemcreatelink'>#", "<br><span class='itemeffectlink'>Creates: </span>\\0", $item['html']);
				$item['html'] = str_replace("<span class='iname'>", '', $item['html']);
				$item['html'] = str_replace('</span></span>', '</span>', $item['html']);
				$item['html'] = str_replace("<br /><br /><span class='akznotice'>", "<span class='akznotice'>", $item['html']);
				
				// Extract the item color from the HTML.
				preg_match("#<span class='(.*?)'>#s", $item['html'], $match);
				$item['color'] = $match[1];
				
				// If this is a set, grab the set bonuses and add it to the html.
				$item_set_id = $this->xml_helper->fetch($xml_data, 'wowitem/setid');
				if ($item_set_id !== false && ($item_set_id != '0'))
				{
					// Read the item set page.
					$data = downloadFile('http://wow.allakhazam.com/dev/wow/itemset.pl?setid=' . $item_set_id);
					
					if($data !== false)
					{
						// Extract the set bonus html from this page.
						preg_match('#Set Bonuses:</div>(.*?)<br/><div class#s', $data, $match);
						$item_set_bonuses = $match[1];
						
						// Fix up the html a bit
						$item_set_bonuses = str_replace('/db/spell.html', 'http://wow.allakhazam.com/db/spell.html', $item_set_bonuses);
						$item_set_bonuses = str_replace("<a", "<a class='setbonus' target='_new'", $item_set_bonuses);
						$item_set_bonuses = str_replace('"', '\'', $item_set_bonuses);
						$item_set_bonuses = "<span class='setbonus'>" . $item_set_bonuses . "</span>";
						
						// Insert the set bonus text into the display html;
						$item['html'] = preg_replace('#setid=(.*?)</span></a>#s', '\\0' . $item_set_bonuses, $item['html']);
					}
					else
					{
						$item_parse_failed = false;	
					}
				}
			}
			else
			{
				$item_parse_failed = false;	
			}

			if ($item_parse_failed === false)
			{
				// Build the final HTML by merging the template and the data we just prepared.
				$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup.tpl'));
				$item['html'] = str_replace('{ITEM_HTML}', $item['html'], $template_html);
			}
			else
			{
				// If Allakhazam was busy or this item doesn't exist and this item isn't cached yet, create some error html.
				$item['icon'] = DEFAULT_ICON_ALLAKHAZAM;
				$item['color'] = 'greyname';
				$item['found'] = '0';
				// Read the template html for an item.
				$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup-error.tpl'));
				$item['html'] = str_replace('{INFO_SITE}', 'Allakhazam', $template_html);
			}
		}
		else
		{
			// If Allakhazam was busy or this item doesn't exist and this item isn't cached yet, create some error html.
			$item['icon'] = DEFAULT_ICON_ALLAKHAZAM;
			$item['color'] = 'greyname';
			$item['found'] = '0';
			// Read the template html for an item.
			$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup-error.tpl'));
			$item['html'] = str_replace('{INFO_SITE}', 'Allakhazam', $template_html);
		}

		return $item;
	}
}
?>