<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
require_once(dirname(__FILE__) . '/xmlhelper.php');
require_once(dirname(__FILE__) . '/HTTPDownloader.php');
require_once(dirname(__FILE__) . '/LocalFileReader.php');

define('DEFAULT_ICON_BUFFED', 'INV_Misc_QuestionMark');

// The main interface to the Buffed Site
class WoWBuffed
{
	var $xml_helper;
	var $method = 'find'; //set default to find...
	var $colornames;
	
	// Constructor
	function WoWBuffed($method)
	{
		$this->xml_helper = new XmlHelperDC14();
		$this->colornames['q0'] = "greyname";
		$this->colornames['q1'] = "whitename";
		$this->colornames['q2'] = "greenname";
		$this->colornames['q3'] = "bluename";
		$this->colornames['q4'] = "purplename";
		$this->colornames['q5'] = "orangename";
		$this->colornames['q6'] = "redname";
		
		if (!empty($method))
				$this->method = $method;
	}
	
	// Cleans up resources used by this object.
	function close()
	{
		$this->xml_helper->close();
	}

	// Attempts to retrieve data for the specified item from Allakhazam.
	function getItem($name)
	{
		global $settings;
		
		// Ignore blank names.
		$tempname = trim($name);
		if (empty($tempname))
		{
			return null;
		}
		
		// set default value...
		$item_found = false;
		$itemid_found = false;
		$wrongitem = true;
		$item = array('name' => $name);
		$item['source'] = '1';
		$item['method'] = $this->method;
		$item['id'] = '-1';
		
		if (is_numeric($name))
		{
			$this->method = 'id';
		}
		
		if ($this->method =='id')
		{
			$item['method'] = 'id';
			$item['source'] = '1';
			$item_id = intval($name, 10);
			$itemid_found = true;
		}
		else
		{
			// Perform the search.
			$data = downloadFile('http://wowdata.buffed.de/?f=' . urlencode($name));
			
			if ($data !== false)
			{		
				// Look for a name match in the search result.
				if(preg_match_all('#"id":"(\d*?)","n":"[0-9](.*?)"#', $data, $matches))
				{
					foreach ($matches[2] as $key => $match)
					{
						$tempname = $match;

						// now check if this is the item we searched
						if(strtoupper($name) == strtoupper($tempname))
						{
							$name = $tempname;
							$item['method'] = 'find';
							$item['source'] = '1';

							// Extract the item's ID from the match.
							$item_id = $matches[1][$key];
							$itemid_found = true;
							
							// get the icon name, maybe the xml file doesn't contain it..
							if (preg_match_all('#"' . $item_id . '":"(.*?)"#', $data, $matches))
								$tempicon_from_search = $matches[1][0];
														
							break;
						}
					}
				}
			}
		}
		
		if($itemid_found == true)
		{	// Retrieve the XML for this item from Buffed.
			$xml_data = downloadFile('http://wowdata.buffed.de/xml/i' . $item_id . ".xml");

			if ($xml_data !== false)
			{
				// ok check if we really got a valid xml file
				$tempname = $this->xml_helper->fetch($xml_data, 'wowitem/InventoryName');			  
				$tempicon = $this->xml_helper->fetch($xml_data, 'wowitem/Icon');
				
				if ($tempicon === false)
					$tempicon = $tempicon_from_search;
				
				if ($tempname !== false)
				{
					$item['name'] = itemstats_fixname_dc14($tempname);
					$item['id'] = $item_id;
					$item['icon'] = $tempicon;
					$item['link'] = 'http://wowdata.buffed.de/?i=' . $item['id'];
					$item['found'] = '1';
					
					$item_found = true;
				}
			}
		}
  	
		// 	If a match was found, retrieve additional info about it.
		if ($item_found)
		{
			$item_parse_failed = false;
			
			// Parse out the display html of this item from the XML		
			$item['html'] = $this->xml_helper->fetch($xml_data, 'wowitem/display_html');
			
			if ($item['html'] !== false)
			{
				$item['html'] = str_replace("\r", '', $item['html']);
				$item['html'] = str_replace("\n", '', $item['html']);
				$item['html'] = '<div class="wowitem">' . $item['html'] . '</div>';
				
				// Extract the item color from the HTML.
				preg_match('#<b class="(.*?)">#s', $item['html'], $match);
				$item['color'] = $this->colornames[$match[1]];
				$item['html'] = preg_replace('#<b class="(.*?)">#s', '<b class="'.$item['color'].'">', $item['html']);
				$item['html'] = preg_replace('#<span class="' . $match[1] . '">#s', '<span class="' . $item['color'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q0(.*?)">#s', 'class="' . $this->colornames['q0'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q1(.*?)">#s', 'class="' . $this->colornames['q1'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q2(.*?)">#s', 'class="' . $this->colornames['q2'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q3(.*?)">#s', 'class="' . $this->colornames['q3'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q4(.*?)">#s', 'class="' . $this->colornames['q4'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q5(.*?)">#s', 'class="' . $this->colornames['q5'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q6(.*?)">#s', 'class="' . $this->colornames['q6'] . '">', $item['html']);
				$item['html'] = preg_replace('#class="q(.*?)">#s', 'class="' . $this->colornames['q'] . '">', $item['html']);
								
				// Fix up the html a bit.
				$item['html'] = str_replace('<table width="100%">', '<table width="100%" border="0" cellpadding="0" cellspacing="0">', $item['html']);
				//$item['html'] = str_replace("tooltip", "wowitemt", $item['html']);
				$item['html'] = str_replace("&apos;", "'", $item['html']);
				$item['html'] = str_replace('"', "'", $item['html']);
				$item['html'] = str_replace('<span class=\'itemsocket\'>', '<span class=\'greyname\'>', $item['html']);
				$item['html'] = str_replace('<span class=\'itemdisabled\'>', '<span class=\'greyname\'>', $item['html']);
			}
			else
			{
				$item_parse_failed = true;
			}
			
			if ($item_parse_failed === false)
			{
				// Build the final HTML by merging the template and the data we just prepared.
				$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup.tpl'));
				$item['html'] = str_replace('{ITEM_HTML}', $item['html'], $template_html);
			}
			else
			{
				// If Buffed was busy or this item doesn't exist and this item isn't cached yet, create some error html.
				$item['icon'] = DEFAULT_ICON_BUFFED;
				$item['color'] = 'greyname';
				$item['found'] = '0';
				
				// Read the template html for an item.
				$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup-error.tpl'));
				$item['html'] = str_replace('{INFO_SITE}', 'Buffed', $template_html);
			}
		}
		else
		{
			// If Buffed was busy or this item doesn't exist and this item isn't cached yet, create some error html.
			$item['icon'] = DEFAULT_ICON_BUFFED;
			$item['color'] = 'greyname';
			$item['found'] = '0';

			// Read the template html for an item.
			$template_html = trim(readLocalFile($settings['default_theme_dir'] . '/itemstats/templates/popup-error.tpl'));
			$item['html'] = str_replace('{INFO_SITE}', 'Buffed', $template_html);
		}
		
		return $item;
	}
}
?>
