<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
function itemstats_parse_dc14($message)
{
  global $db_character_set, $scripturl, $modSettings, $settings, $user_settings;
  static $iconcount = 0;
  		
	if (!empty($message))
	{
    //don't allow encase of [wowitem] tag
    if (count($message) > 1)
    {
      if (strstr($message[0], '[wowitem]') || strstr($message[0], '[item]') || strstr($message[0], '<wowitem>'))
        return $message;
    }
    else
    {
      if (strstr($message, '[wowitem]') || strstr($message, '[item]') || strstr($message, '<wowitem>'))
        return $message;
    }

		//ok lets get the right informations...
		$array_count = count($message);
		
		//ok first set the default sources...
		if (!empty($modSettings['wowitemstats_defaultsource_list']))
			$source = $modSettings['wowitemstats_defaultsource_list'];
		else
			$source = '0';
		
		switch($array_count)
		{
			case 0:
				return $message;
				break;
			case 1:
				if (!is_numeric($message))
					$method = 'find';
				else
					$method = 'id';
				
				$item_name = itemstats_fixname_dc14($message);
				break;
			default:
				if (strtoupper($message[1]) == strtoupper('find') || strtoupper($message[1]) == strtoupper('id'))
				{
					$method = $message[1];
					
					switch(intval($message[2]))
					{
						case 0:
							$source = '0';
							break;
						case 1:
							$source = '1';
							break;
						case 2:
							$source = '2';
							break;
						default:
							$source = $modSettings['wowitemstats_defaultsource_list'];
							break;
					}
				}
				elseif (strtoupper($message[2]) == strtoupper('find') || strtoupper($message[2] == 'id'))
				{
					$method = $message[2];
					
					switch(intval($message[1]))
					{
						case 0:
							$source = '0';
							break;
						case 1:
							$source = '1';
							break;
						case 2:
							$source = '2';
							break;
						default:
							$source = $modSettings['wowitemstats_defaultsource_list'];
							break;
					}					  
					
				}
				else
				{
					//hmm something went wrong.. use the defaults..	
					if (!is_numeric($message[0]))
						$method = 'find';
					else
						$method = 'id';
				}

				$item_name = itemstats_fixname_dc14($message[0]);
				break;
		}

		$item_stats = new ItemStatsDC14($source, $method);
		
		// Get the proper name of this item.
		$item_name = $item_stats->getItemName($item_name, true);
		
		// Initialize the html.
		$item_html = '<span class="smfitemstatsbox">[' . $item_name . ']</span>';

		// Get the color of this item and apply it to the html.
		$item_color = $item_stats->getItemColor($item_name);
		if (!empty($item_color))
		{
			$item_html = "<span class='" . $item_color . "'>" . $item_html . "</span>";
		}

		// Get the tooltip html for this item and apply it to the html.
		$item_tooltip_html = $item_stats->getItemTooltipHtml($item_name);
		if (!empty($item_tooltip_html))
		{
			$item_html = /*"<span " .*/ $item_tooltip_html . ">" . $item_html /*. "</span>"*/;
		}

		// If this item has a link to the info site, add this link to the HTML.  If it doesn't have a link, it
		// means the item hasn't been found yet, so put up a link to the update page instead.
		$item_link = $item_stats->getItemLink($item_name);
		$item_icon = $item_stats->getItemIconLink($item_name);
		$iconcount++;
		if (!empty($item_link))
		{
			$item_html = "<script type=\"text/javascript\"><!-- pic" . $iconcount . " = new Image(64,64); pic" . $iconcount . ".src=\"" . $item_icon . "\"; //--></script><a class='forumitemlink' target='_blank' href='" . $item_link . "' " /*"'>"*/ . $item_html . "</a>";
		}
		else
		{
			//$item_link = 'itemstats/updateitem.php?item=' . urlencode(urlencode($item_name)) . '&lang=' . urlencode(urlencode($sources));
			$item_link = $scripturl . '?action=updatewowitem;item=' . urlencode(urlencode($item_name)) . ';source=' . urlencode(urlencode($source)) . ';method=' . urlencode(urlencode($method));
			$item_html = "<script type=\"text/javascript\"><!-- pic" . $iconcount . " = new Image(64,64); pic" . $iconcount . ".src=\"" . $item_icon . "\"; //--></script><a class='forumitemlink' href='$item_link' " /*>"*/ . $item_html . "</a>";
		}

    if (isset($db_character_set))
    {
      if (strcasecmp($db_character_set, 'utf8') == 0)
      {
        $item_html = utf8_encode($item_html);
      }
    }
    else
    {
      if (isset($user_settings['lngfile']))
      {
        if (strpos($user_settings['lngfile'], 'utf8'))
          $item_html = utf8_encode($item_html);      
      }
    }
	
	// replace the icon string with lowercase icon string to be compatible with wowhead..
	if (strpos($item_icon, 'wowhead.com'))
		$item_html = str_replace($item_icon, strtolower($item_icon), $item_html);

		// Finally, replace the bbcode with the html.
		if ($array_count == 1)
		{
      $message = $item_html;
		}
		else
		{
			$message[0] =	$item_html;
		}
	}
  
	return $message;
}

function itemstats_fixname_dc14($name)
{
  if(is_utf8_dc14($name))
    $name = utf8_decode($name);
	
  $name = strip_tags($name);    
  $name = str_replace('\&#039;', '\'', $name);  
  $name = str_replace('&#039;', '\'', $name);
  $name = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $name);
  $name = preg_replace('~&#([0-9]+);~e', 'chr(\\1)', $name);
  $name = str_replace('\\', '', $name);  
  
  $trans_tbl = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
  $trans_tbl = array_flip($trans_tbl);  
  $name = strtr($name, $trans_tbl);
  $name = strip_tags($name);
    
  return $name;
}

// Returns true if $string is valid UTF-8 and false otherwise.
function is_utf8_dc14($string) {
  
  // From http://w3.org/International/questions/qa-forms-utf-8.html
  return preg_match('%^(?:
        [\x09\x0A\x0D\x20-\x7E]            # ASCII
        | [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
        |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
        | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
        |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
        |  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
        | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
        |  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
        )*$%xs', $string);
  
} // function is_utf8_dc14

?>